if(NOT MYX_REDIS_IS_EXTERNAL_PROJECT)
  set(MYX_REDIS_PREFIX "" CACHE PATH "The path to the prefix of an myx-redis installation")
  set(MYX_REDIS_INCLUDE_DIR "" CACHE PATH "The path to the headers of an myx-redis installation")
  set(MYX_REDIS_LIBRARY_DIR "" CACHE PATH "The path to the library of an myx-redis installation")

  set(_search_paths "")
  if(MYX_REDIS_INCLUDE_DIR AND EXISTS ${MYX_REDIS_INCLUDE_DIR})
    list(APPEND _search_paths ${MYX_REDIS_INCLUDE_DIR})
  endif()
  if(MYX_REDIS_PREFIX AND EXISTS ${MYX_REDIS_PREFIX})
    list(APPEND _search_paths "${MYX_REDIS_PREFIX}/include")
  endif()
  find_path(
    MYX_REDIS_INCLUDE_DIRS
    NAMES myx/redis/sync_client.hpp
    PATHS ${_search_paths})

  set(_search_paths "")
  if(MYX_REDIS_LIBRARY_DIR AND EXISTS ${MYX_REDIS_LIBRARY_DIR})
    list(APPEND _search_paths ${MYX_REDIS_LIBRARY_DIR})
  endif()
  if(MYX_REDIS_PREFIX AND EXISTS ${MYX_REDIS_PREFIX})
    list(APPEND _search_paths "${MYX_REDIS_PREFIX}/lib")
  endif()
  find_library(
    MYX_REDIS_LIBRARIES
    NAMES myx-redis
    PATHS ${_search_paths})
  unset(_search_paths)

  if(MYX_REDIS_INCLUDE_DIRS AND MYX_REDIS_LIBRARIES)
    set(MYX_REDIS_FOUND TRUE)
  endif()

  if(MYX_REDIS_FOUND)
    if(NOT MYX_REDIS_FIND_QUIETLY)
      message(STATUS "Found myx-redis")
    endif()
    set(HAVE_MYX_REDIS 1)
  elseif(MYX_REDIS_FOUND)
    if(MYX_REDIS_FIND_REQUIRED)
      message(FATAL_ERROR "Could not find myx-redis")
    endif()
  endif()
endif()
